# Files

## Upload File

`FileCreateResponse Files.Create(FileCreateParamsparameters, CancellationTokencancellationToken = default)`

**post** `/api/v1/beta/files`

Upload a file using multipart/form-data.

Set `purpose` to indicate how the file will be used:
`user_data`, `parse`, `extract`, `classify`, `split`,
`sheet`, or `agent_app`.

Returns the created file metadata including its ID for use
in subsequent parse, extract, or classify operations.

### Parameters

- `FileCreateParams parameters`

  - `required string file`

    Body param: The file to upload

  - `required string purpose`

    Body param: The intended purpose of the file. Valid values: 'user_data', 'parse', 'extract', 'split', 'classify', 'sheet', 'agent_app'. This determines the storage and retention policy for the file.

  - `string? organizationID`

    Query param

  - `string? projectID`

    Query param

  - `string? externalFileID`

    Body param: The ID of the file in the external system

### Returns

- `class FileCreateResponse:`

  An uploaded file.

  - `required string ID`

    Unique file identifier

  - `required string Name`

    File name including extension

  - `required string ProjectID`

    Project this file belongs to

  - `PresignedUrl? DownloadUrl`

    Schema for a presigned URL.

    - `required DateTimeOffset ExpiresAt`

      The time at which the presigned URL expires

    - `required string Url`

      A presigned URL for IO operations against a private file

    - `IReadOnlyDictionary<string, string>? FormFields`

      Form fields for a presigned POST request

  - `DateTimeOffset? ExpiresAt`

    When the file expires and may be automatically removed. Null means no expiration.

  - `string? ExternalFileID`

    Optional ID for correlating with an external system

  - `string? FileType`

    File extension (pdf, docx, png, etc.)

  - `DateTimeOffset? LastModifiedAt`

    When the file was last modified (ISO 8601)

  - `string? Purpose`

    How the file will be used: user_data, parse, extract, classify, split, sheet, or agent_app

### Example

```csharp
FileCreateParams parameters = new()
{
    File = Encoding.UTF8.GetBytes("Example data"),
    Purpose = "purpose",
};

var file = await client.Files.Create(parameters);

Console.WriteLine(file);
```

#### Response

```json
{
  "id": "dfl-aaaaaaaa-bbbb-cccc-dddd-eeeeeeeeeeee",
  "name": "invoice.pdf",
  "project_id": "123e4567-e89b-12d3-a456-426614174000",
  "download_url": {
    "expires_at": "2019-12-27T18:11:19.117Z",
    "url": "https://example.com",
    "form_fields": {
      "foo": "string"
    }
  },
  "expires_at": "2019-12-27T18:11:19.117Z",
  "external_file_id": "ext-12345",
  "file_type": "pdf",
  "last_modified_at": "2019-12-27T18:11:19.117Z",
  "purpose": "parse"
}
```

## Query Files

`FileQueryResponse Files.Query(FileQueryParams?parameters, CancellationTokencancellationToken = default)`

**post** `/api/v1/beta/files/query`

Query files with filtering and pagination. Deprecated: use `GET /files`.

### Parameters

- `FileQueryParams parameters`

  - `string? organizationID`

    Query param

  - `string? projectID`

    Query param

  - `Filter? filter`

    Body param: Filter parameters for file queries.

    - `string? DataSourceID`

      Filter by data source ID

    - `string? ExternalFileID`

      Filter by external file ID

    - `IReadOnlyList<string>? FileIds`

      Filter by specific file IDs

    - `string? FileName`

      Filter by file name

    - `Boolean? OnlyManuallyUploaded`

      Filter only manually uploaded files (data_source_id is null)

    - `string? ProjectID`

      Filter by project ID

  - `string? orderBy`

    Body param: A comma-separated list of fields to order by, sorted in ascending order. Use 'field_name desc' to specify descending order.

  - `Long? pageSize`

    Body param: The maximum number of items to return. The service may return fewer than this value. If unspecified, a default page size will be used. The maximum value is typically 1000; values above this will be coerced to the maximum.

  - `string? pageToken`

    Body param: A page token, received from a previous list call. Provide this to retrieve the subsequent page.

### Returns

- `class FileQueryResponse:`

  Paginated list of files.

  - `required IReadOnlyList<Item> Items`

    The list of items.

    - `required string ID`

      Unique file identifier

    - `required string Name`

      File name including extension

    - `required string ProjectID`

      Project this file belongs to

    - `PresignedUrl? DownloadUrl`

      Schema for a presigned URL.

      - `required DateTimeOffset ExpiresAt`

        The time at which the presigned URL expires

      - `required string Url`

        A presigned URL for IO operations against a private file

      - `IReadOnlyDictionary<string, string>? FormFields`

        Form fields for a presigned POST request

    - `DateTimeOffset? ExpiresAt`

      When the file expires and may be automatically removed. Null means no expiration.

    - `string? ExternalFileID`

      Optional ID for correlating with an external system

    - `string? FileType`

      File extension (pdf, docx, png, etc.)

    - `DateTimeOffset? LastModifiedAt`

      When the file was last modified (ISO 8601)

    - `string? Purpose`

      How the file will be used: user_data, parse, extract, classify, split, sheet, or agent_app

  - `string? NextPageToken`

    A token, which can be sent as page_token to retrieve the next page. If this field is omitted, there are no subsequent pages.

  - `Long? TotalSize`

    The total number of items available. This is only populated when specifically requested. The value may be an estimate and can be used for display purposes only.

### Example

```csharp
FileQueryParams parameters = new();

var response = await client.Files.Query(parameters);

Console.WriteLine(response);
```

#### Response

```json
{
  "items": [
    {
      "id": "dfl-aaaaaaaa-bbbb-cccc-dddd-eeeeeeeeeeee",
      "name": "invoice.pdf",
      "project_id": "123e4567-e89b-12d3-a456-426614174000",
      "download_url": {
        "expires_at": "2019-12-27T18:11:19.117Z",
        "url": "https://example.com",
        "form_fields": {
          "foo": "string"
        }
      },
      "expires_at": "2019-12-27T18:11:19.117Z",
      "external_file_id": "ext-12345",
      "file_type": "pdf",
      "last_modified_at": "2019-12-27T18:11:19.117Z",
      "purpose": "parse"
    }
  ],
  "next_page_token": "next_page_token",
  "total_size": 0
}
```

## List Files

`FileListPageResponse Files.List(FileListParams?parameters, CancellationTokencancellationToken = default)`

**get** `/api/v1/beta/files`

List files with optional filtering and pagination.

Filter by `file_name`, `file_ids`, or `external_file_id`.
Supports cursor-based pagination and custom ordering.

### Parameters

- `FileListParams parameters`

  - `IReadOnlyList<string>? expand`

    Fields to expand on each file.

  - `string? externalFileID`

    Filter by external file ID.

  - `IReadOnlyList<string>? fileIds`

    Filter by specific file IDs.

  - `string? fileName`

    Filter by file name (exact match).

  - `string? orderBy`

    A comma-separated list of fields to order by, sorted in ascending order. Use 'field_name desc' to specify descending order.

  - `string? organizationID`

  - `Long? pageSize`

    The maximum number of items to return. Defaults to 50, maximum is 1000.

  - `string? pageToken`

    A page token received from a previous list call. Provide this to retrieve the subsequent page.

  - `string? projectID`

### Returns

- `class FileListPageResponse:`

  Paginated list of files.

  - `required IReadOnlyList<FileListResponse> Items`

    The list of items.

    - `required string ID`

      Unique file identifier

    - `required string Name`

      File name including extension

    - `required string ProjectID`

      Project this file belongs to

    - `PresignedUrl? DownloadUrl`

      Schema for a presigned URL.

      - `required DateTimeOffset ExpiresAt`

        The time at which the presigned URL expires

      - `required string Url`

        A presigned URL for IO operations against a private file

      - `IReadOnlyDictionary<string, string>? FormFields`

        Form fields for a presigned POST request

    - `DateTimeOffset? ExpiresAt`

      When the file expires and may be automatically removed. Null means no expiration.

    - `string? ExternalFileID`

      Optional ID for correlating with an external system

    - `string? FileType`

      File extension (pdf, docx, png, etc.)

    - `DateTimeOffset? LastModifiedAt`

      When the file was last modified (ISO 8601)

    - `string? Purpose`

      How the file will be used: user_data, parse, extract, classify, split, sheet, or agent_app

  - `string? NextPageToken`

    A token, which can be sent as page_token to retrieve the next page. If this field is omitted, there are no subsequent pages.

  - `Long? TotalSize`

    The total number of items available. This is only populated when specifically requested. The value may be an estimate and can be used for display purposes only.

### Example

```csharp
FileListParams parameters = new();

var page = await client.Files.List(parameters);
await foreach (var item in page.Paginate())
{
    Console.WriteLine(item);
}
```

#### Response

```json
{
  "items": [
    {
      "id": "dfl-aaaaaaaa-bbbb-cccc-dddd-eeeeeeeeeeee",
      "name": "invoice.pdf",
      "project_id": "123e4567-e89b-12d3-a456-426614174000",
      "download_url": {
        "expires_at": "2019-12-27T18:11:19.117Z",
        "url": "https://example.com",
        "form_fields": {
          "foo": "string"
        }
      },
      "expires_at": "2019-12-27T18:11:19.117Z",
      "external_file_id": "ext-12345",
      "file_type": "pdf",
      "last_modified_at": "2019-12-27T18:11:19.117Z",
      "purpose": "parse"
    }
  ],
  "next_page_token": "next_page_token",
  "total_size": 0
}
```

## Delete File

`Files.Delete(FileDeleteParamsparameters, CancellationTokencancellationToken = default)`

**delete** `/api/v1/beta/files/{file_id}`

Delete a file from the project.

### Parameters

- `FileDeleteParams parameters`

  - `required string fileID`

  - `string? organizationID`

  - `string? projectID`

### Example

```csharp
FileDeleteParams parameters = new()
{
    FileID = "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e"
};

await client.Files.Delete(parameters);
```

## Read File Content

`PresignedUrl Files.Get(FileGetParamsparameters, CancellationTokencancellationToken = default)`

**get** `/api/v1/beta/files/{file_id}/content`

Get a presigned URL to download the file content.

### Parameters

- `FileGetParams parameters`

  - `required string fileID`

  - `Long? expiresAtSeconds`

  - `string? organizationID`

  - `string? projectID`

### Returns

- `class PresignedUrl:`

  Schema for a presigned URL.

  - `required DateTimeOffset ExpiresAt`

    The time at which the presigned URL expires

  - `required string Url`

    A presigned URL for IO operations against a private file

  - `IReadOnlyDictionary<string, string>? FormFields`

    Form fields for a presigned POST request

### Example

```csharp
FileGetParams parameters = new()
{
    FileID = "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e"
};

var presignedUrl = await client.Files.Get(parameters);

Console.WriteLine(presignedUrl);
```

#### Response

```json
{
  "expires_at": "2019-12-27T18:11:19.117Z",
  "url": "https://example.com",
  "form_fields": {
    "foo": "string"
  }
}
```

## Domain Types

### File

- `class File:`

  Schema for a file.

  - `required string ID`

    Unique identifier

  - `required string Name`

  - `required string ProjectID`

    The ID of the project that the file belongs to

  - `DateTimeOffset? CreatedAt`

    Creation datetime

  - `string? DataSourceID`

    The ID of the data source that the file belongs to

  - `DateTimeOffset? ExpiresAt`

    The expiration date for the file. Files past this date can be deleted.

  - `string? ExternalFileID`

    The ID of the file in the external system

  - `Long? FileSize`

    Size of the file in bytes

  - `string? FileType`

    File type (e.g. pdf, docx, etc.)

  - `DateTimeOffset? LastModifiedAt`

    The last modified time of the file

  - `IReadOnlyDictionary<string, PermissionInfo?>? PermissionInfo`

    Permission information for the file

    - `IReadOnlyDictionary<string, JsonElement>`

    - `IReadOnlyList<JsonElement>`

    - `string`

    - `Double`

    - `Boolean`

  - `string? Purpose`

    The intended purpose of the file (e.g., 'user_data', 'parse', 'extract', 'split', 'classify')

  - `IReadOnlyDictionary<string, ResourceInfo?>? ResourceInfo`

    Resource information for the file

    - `IReadOnlyDictionary<string, JsonElement>`

    - `IReadOnlyList<JsonElement>`

    - `string`

    - `Double`

    - `Boolean`

  - `DateTimeOffset? UpdatedAt`

    Update datetime

### Presigned URL

- `class PresignedUrl:`

  Schema for a presigned URL.

  - `required DateTimeOffset ExpiresAt`

    The time at which the presigned URL expires

  - `required string Url`

    A presigned URL for IO operations against a private file

  - `IReadOnlyDictionary<string, string>? FormFields`

    Form fields for a presigned POST request
